/* FILE GENERATED BY /builddir/build/BUILD/naev-nodata-0.10.2/redhat-linux-build/../src/shaders_c_gen.py */
#include <string.h>
#include "shaders.gen.h"
#include "opengl_shader.h"

Shaders shaders;

static int nsimpleshaders = 0;

static int shaders_cmp( const void *p1, const void *p2 )
{
   const SimpleShader **s1 = (const SimpleShader**) p1;
   const SimpleShader **s2 = (const SimpleShader**) p2;
   return strcmp( (*s1)->name, (*s2)->name );
}

static int shaders_loadSimple( const char *name, SimpleShader *shd, const char *fs_path )
{
   shd->name   = name;
   shd->program = gl_program_vert_frag( "project_pos.vert", fs_path );
   shd->vertex = glGetAttribLocation( shd->program, "vertex" );
   shd->projection = glGetUniformLocation( shd->program, "projection" );
   shd->color  = glGetUniformLocation( shd->program, "color" );
   shd->dimensions = glGetUniformLocation( shd->program, "dimensions" );
   shd->dt     = glGetUniformLocation( shd->program, "dt" );
   shd->paramf = glGetUniformLocation( shd->program, "paramf" );
   shd->parami = glGetUniformLocation( shd->program, "parami" );
   shd->paramv = glGetUniformLocation( shd->program, "paramv" );

   /* Add to list. */
   shaders.simple_shaders[ nsimpleshaders++ ] = shd;

   return 0;
}

const SimpleShader *shaders_getSimple( const char *name )
{
   const SimpleShader shd = { .name=name };
   const SimpleShader *shdptr = &shd;
   const SimpleShader **found = bsearch( &shdptr, shaders.simple_shaders, nsimpleshaders, sizeof(SimpleShader*), shaders_cmp );
   if (found!=NULL)
      return *found;
   return NULL;
}

void shaders_load (void) {
   shaders.solid.program = gl_program_vert_frag("project.vert", "solid.frag");
   shaders.solid.vertex = glGetAttribLocation(shaders.solid.program, "vertex");
   shaders.solid.projection = glGetUniformLocation(shaders.solid.program, "projection");
   shaders.solid.color = glGetUniformLocation(shaders.solid.program, "color");

   shaders.trail.program = gl_program_vert_frag("project_pos.vert", "trail.frag");
   shaders.trail.vertex = glGetAttribLocation(shaders.trail.program, "vertex");
   shaders.trail.projection = glGetUniformLocation(shaders.trail.program, "projection");
   shaders.trail.c1 = glGetUniformLocation(shaders.trail.program, "c1");
   shaders.trail.c2 = glGetUniformLocation(shaders.trail.program, "c2");
   shaders.trail.t1 = glGetUniformLocation(shaders.trail.program, "t1");
   shaders.trail.t2 = glGetUniformLocation(shaders.trail.program, "t2");
   shaders.trail.dt = glGetUniformLocation(shaders.trail.program, "dt");
   shaders.trail.pos1 = glGetUniformLocation(shaders.trail.program, "pos1");
   shaders.trail.pos2 = glGetUniformLocation(shaders.trail.program, "pos2");
   shaders.trail.r = glGetUniformLocation(shaders.trail.program, "r");
   shaders.trail.nebu_col = glGetUniformLocation(shaders.trail.program, "nebu_col");
   if (gl_has( OPENGL_SUBROUTINES )) {
      shaders.trail.trail_func.uniform = glGetSubroutineUniformLocation( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_func" );
      shaders.trail.trail_func.trail_default = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_default" );
      shaders.trail.trail_func.trail_pulse = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_pulse" );
      shaders.trail.trail_func.trail_wave = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_wave" );
      shaders.trail.trail_func.trail_flame = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_flame" );
      shaders.trail.trail_func.trail_nebula = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_nebula" );
      shaders.trail.trail_func.trail_arc = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_arc" );
      shaders.trail.trail_func.trail_bubbles = glGetSubroutineIndex( shaders.trail.program, GL_FRAGMENT_SHADER, "trail_bubbles" );
   }

   shaders.smooth.program = gl_program_vert_frag("smooth.vert", "smooth.frag");
   shaders.smooth.vertex = glGetAttribLocation(shaders.smooth.program, "vertex");
   shaders.smooth.vertex_color = glGetAttribLocation(shaders.smooth.program, "vertex_color");
   shaders.smooth.projection = glGetUniformLocation(shaders.smooth.program, "projection");

   shaders.texture.program = gl_program_vert_frag("texture.vert", "texture.frag");
   shaders.texture.vertex = glGetAttribLocation(shaders.texture.program, "vertex");
   shaders.texture.projection = glGetUniformLocation(shaders.texture.program, "projection");
   shaders.texture.color = glGetUniformLocation(shaders.texture.program, "color");
   shaders.texture.tex_mat = glGetUniformLocation(shaders.texture.program, "tex_mat");
   shaders.texture.sampler = glGetUniformLocation(shaders.texture.program, "sampler");

   shaders.texture_interpolate.program = gl_program_vert_frag("texture.vert", "texture_interpolate.frag");
   shaders.texture_interpolate.vertex = glGetAttribLocation(shaders.texture_interpolate.program, "vertex");
   shaders.texture_interpolate.projection = glGetUniformLocation(shaders.texture_interpolate.program, "projection");
   shaders.texture_interpolate.color = glGetUniformLocation(shaders.texture_interpolate.program, "color");
   shaders.texture_interpolate.tex_mat = glGetUniformLocation(shaders.texture_interpolate.program, "tex_mat");
   shaders.texture_interpolate.sampler1 = glGetUniformLocation(shaders.texture_interpolate.program, "sampler1");
   shaders.texture_interpolate.sampler2 = glGetUniformLocation(shaders.texture_interpolate.program, "sampler2");
   shaders.texture_interpolate.inter = glGetUniformLocation(shaders.texture_interpolate.program, "inter");

   shaders.stealthoverlay.program = gl_program_vert_frag("texture.vert", "stealthoverlay.frag");
   shaders.stealthoverlay.vertex = glGetAttribLocation(shaders.stealthoverlay.program, "vertex");
   shaders.stealthoverlay.projection = glGetUniformLocation(shaders.stealthoverlay.program, "projection");
   shaders.stealthoverlay.color = glGetUniformLocation(shaders.stealthoverlay.program, "color");
   shaders.stealthoverlay.tex_mat = glGetUniformLocation(shaders.stealthoverlay.program, "tex_mat");

   shaders.nebula.program = gl_program_vert_frag("nebula.vert", "nebula_overlay.frag");
   shaders.nebula.vertex = glGetAttribLocation(shaders.nebula.program, "vertex");
   shaders.nebula.projection = glGetUniformLocation(shaders.nebula.program, "projection");
   shaders.nebula.hue = glGetUniformLocation(shaders.nebula.program, "hue");
   shaders.nebula.nonuniformity = glGetUniformLocation(shaders.nebula.program, "nonuniformity");
   shaders.nebula.horizon = glGetUniformLocation(shaders.nebula.program, "horizon");
   shaders.nebula.eddy_scale = glGetUniformLocation(shaders.nebula.program, "eddy_scale");
   shaders.nebula.time = glGetUniformLocation(shaders.nebula.program, "time");

   shaders.nebula_background.program = gl_program_vert_frag("nebula.vert", "nebula_background.frag");
   shaders.nebula_background.vertex = glGetAttribLocation(shaders.nebula_background.program, "vertex");
   shaders.nebula_background.projection = glGetUniformLocation(shaders.nebula_background.program, "projection");
   shaders.nebula_background.hue = glGetUniformLocation(shaders.nebula_background.program, "hue");
   shaders.nebula_background.nonuniformity = glGetUniformLocation(shaders.nebula_background.program, "nonuniformity");
   shaders.nebula_background.eddy_scale = glGetUniformLocation(shaders.nebula_background.program, "eddy_scale");
   shaders.nebula_background.time = glGetUniformLocation(shaders.nebula_background.program, "time");
   shaders.nebula_background.volatility = glGetUniformLocation(shaders.nebula_background.program, "volatility");

   shaders.nebula_puff.program = gl_program_vert_frag("project_pos.vert", "nebula_puff.frag");
   shaders.nebula_puff.vertex = glGetAttribLocation(shaders.nebula_puff.program, "vertex");
   shaders.nebula_puff.projection = glGetUniformLocation(shaders.nebula_puff.program, "projection");
   shaders.nebula_puff.nebu_col = glGetUniformLocation(shaders.nebula_puff.program, "nebu_col");
   shaders.nebula_puff.time = glGetUniformLocation(shaders.nebula_puff.program, "time");
   shaders.nebula_puff.r = glGetUniformLocation(shaders.nebula_puff.program, "r");

   shaders.nebula_map.program = gl_program_vert_frag("system_map.vert", "nebula_map.frag");
   shaders.nebula_map.vertex = glGetAttribLocation(shaders.nebula_map.program, "vertex");
   shaders.nebula_map.projection = glGetUniformLocation(shaders.nebula_map.program, "projection");
   shaders.nebula_map.hue = glGetUniformLocation(shaders.nebula_map.program, "hue");
   shaders.nebula_map.time = glGetUniformLocation(shaders.nebula_map.program, "time");
   shaders.nebula_map.globalpos = glGetUniformLocation(shaders.nebula_map.program, "globalpos");
   shaders.nebula_map.alpha = glGetUniformLocation(shaders.nebula_map.program, "alpha");
   shaders.nebula_map.volatility = glGetUniformLocation(shaders.nebula_map.program, "volatility");

   shaders.points.program = gl_program_vert_frag("smooth.vert", "points.frag");
   shaders.points.vertex = glGetAttribLocation(shaders.points.program, "vertex");
   shaders.points.vertex_color = glGetAttribLocation(shaders.points.program, "vertex_color");
   shaders.points.projection = glGetUniformLocation(shaders.points.program, "projection");

   shaders.stars.program = gl_program_vert_frag("stars.vert", "stars.frag");
   shaders.stars.vertex = glGetAttribLocation(shaders.stars.program, "vertex");
   shaders.stars.brightness = glGetAttribLocation(shaders.stars.program, "brightness");
   shaders.stars.projection = glGetUniformLocation(shaders.stars.program, "projection");
   shaders.stars.star_xy = glGetUniformLocation(shaders.stars.program, "star_xy");
   shaders.stars.dims = glGetUniformLocation(shaders.stars.program, "dims");
   shaders.stars.xy = glGetUniformLocation(shaders.stars.program, "xy");
   shaders.stars.use_lines = glGetUniformLocation(shaders.stars.program, "use_lines");

   shaders.lines.program = gl_program_vert_frag("lines.vert", "lines.frag");
   shaders.lines.vertex = glGetAttribLocation(shaders.lines.program, "vertex");
   shaders.lines.projection = glGetUniformLocation(shaders.lines.program, "projection");
   shaders.lines.colour = glGetUniformLocation(shaders.lines.program, "colour");

   shaders.font.program = gl_program_vert_frag("font.vert", "font.frag");
   shaders.font.vertex = glGetAttribLocation(shaders.font.program, "vertex");
   shaders.font.tex_coord = glGetAttribLocation(shaders.font.program, "tex_coord");
   shaders.font.projection = glGetUniformLocation(shaders.font.program, "projection");
   shaders.font.m = glGetUniformLocation(shaders.font.program, "m");
   shaders.font.color = glGetUniformLocation(shaders.font.program, "color");
   shaders.font.outline_color = glGetUniformLocation(shaders.font.program, "outline_color");

   shaders.beam.program = gl_program_vert_frag("project_pos.vert", "beam.frag");
   shaders.beam.vertex = glGetAttribLocation(shaders.beam.program, "vertex");
   shaders.beam.projection = glGetUniformLocation(shaders.beam.program, "projection");
   shaders.beam.color = glGetUniformLocation(shaders.beam.program, "color");
   shaders.beam.dt = glGetUniformLocation(shaders.beam.program, "dt");
   shaders.beam.r = glGetUniformLocation(shaders.beam.program, "r");
   shaders.beam.dimensions = glGetUniformLocation(shaders.beam.program, "dimensions");
   if (gl_has( OPENGL_SUBROUTINES )) {
      shaders.beam.beam_func.uniform = glGetSubroutineUniformLocation( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_func" );
      shaders.beam.beam_func.beam_default = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_default" );
      shaders.beam.beam_func.beam_wave = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_wave" );
      shaders.beam.beam_func.beam_arc = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_arc" );
      shaders.beam.beam_func.beam_helix = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_helix" );
      shaders.beam.beam_func.beam_organic = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_organic" );
      shaders.beam.beam_func.beam_unstable = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_unstable" );
      shaders.beam.beam_func.beam_fuzzy = glGetSubroutineIndex( shaders.beam.program, GL_FRAGMENT_SHADER, "beam_fuzzy" );
   }

   shaders.jump.program = gl_program_vert_frag("project_pos.vert", "jump.frag");
   shaders.jump.vertex = glGetAttribLocation(shaders.jump.program, "vertex");
   shaders.jump.projection = glGetUniformLocation(shaders.jump.program, "projection");
   shaders.jump.progress = glGetUniformLocation(shaders.jump.program, "progress");
   shaders.jump.direction = glGetUniformLocation(shaders.jump.program, "direction");
   shaders.jump.dimensions = glGetUniformLocation(shaders.jump.program, "dimensions");
   shaders.jump.brightness = glGetUniformLocation(shaders.jump.program, "brightness");
   if (gl_has( OPENGL_SUBROUTINES )) {
      shaders.jump.jump_func.uniform = glGetSubroutineUniformLocation( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_func" );
      shaders.jump.jump_func.jump_default = glGetSubroutineIndex( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_default" );
      shaders.jump.jump_func.jump_nebula = glGetSubroutineIndex( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_nebula" );
      shaders.jump.jump_func.jump_organic = glGetSubroutineIndex( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_organic" );
      shaders.jump.jump_func.jump_circular = glGetSubroutineIndex( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_circular" );
      shaders.jump.jump_func.jump_wind = glGetSubroutineIndex( shaders.jump.program, GL_FRAGMENT_SHADER, "jump_wind" );
   }

   shaders.material.program = gl_program_vert_frag("material.vert", "material.frag");
   shaders.material.vertex = glGetAttribLocation(shaders.material.program, "vertex");
   shaders.material.vertex_normal = glGetAttribLocation(shaders.material.program, "vertex_normal");
   shaders.material.vertex_tex = glGetAttribLocation(shaders.material.program, "vertex_tex");
   shaders.material.projection = glGetUniformLocation(shaders.material.program, "projection");
   shaders.material.model = glGetUniformLocation(shaders.material.program, "model");
   shaders.material.map_Kd = glGetUniformLocation(shaders.material.program, "map_Kd");
   shaders.material.map_Ks = glGetUniformLocation(shaders.material.program, "map_Ks");
   shaders.material.map_Ke = glGetUniformLocation(shaders.material.program, "map_Ke");
   shaders.material.map_Bump = glGetUniformLocation(shaders.material.program, "map_Bump");
   shaders.material.Ns = glGetUniformLocation(shaders.material.program, "Ns");
   shaders.material.Ka = glGetUniformLocation(shaders.material.program, "Ka");
   shaders.material.Kd = glGetUniformLocation(shaders.material.program, "Kd");
   shaders.material.Ks = glGetUniformLocation(shaders.material.program, "Ks");
   shaders.material.Ke = glGetUniformLocation(shaders.material.program, "Ke");
   shaders.material.Ni = glGetUniformLocation(shaders.material.program, "Ni");
   shaders.material.d = glGetUniformLocation(shaders.material.program, "d");
   shaders.material.bm = glGetUniformLocation(shaders.material.program, "bm");

   shaders.colorblind.program = gl_program_vert_frag("postprocess.vert", "colorblind.frag");
   shaders.colorblind.VertexPosition = glGetAttribLocation(shaders.colorblind.program, "VertexPosition");
   shaders.colorblind.ClipSpaceFromLocal = glGetUniformLocation(shaders.colorblind.program, "ClipSpaceFromLocal");
   shaders.colorblind.MainTex = glGetUniformLocation(shaders.colorblind.program, "MainTex");

   shaders.shake.program = gl_program_vert_frag("postprocess.vert", "shake.frag");
   shaders.shake.VertexPosition = glGetAttribLocation(shaders.shake.program, "VertexPosition");
   shaders.shake.ClipSpaceFromLocal = glGetUniformLocation(shaders.shake.program, "ClipSpaceFromLocal");
   shaders.shake.MainTex = glGetUniformLocation(shaders.shake.program, "MainTex");
   shaders.shake.shake_pos = glGetUniformLocation(shaders.shake.program, "shake_pos");
   shaders.shake.shake_vel = glGetUniformLocation(shaders.shake.program, "shake_vel");
   shaders.shake.shake_force = glGetUniformLocation(shaders.shake.program, "shake_force");

   shaders.damage.program = gl_program_vert_frag("postprocess.vert", "damage.frag");
   shaders.damage.VertexPosition = glGetAttribLocation(shaders.damage.program, "VertexPosition");
   shaders.damage.ClipSpaceFromLocal = glGetUniformLocation(shaders.damage.program, "ClipSpaceFromLocal");
   shaders.damage.MainTex = glGetUniformLocation(shaders.damage.program, "MainTex");
   shaders.damage.damage_strength = glGetUniformLocation(shaders.damage.program, "damage_strength");
   shaders.damage.love_ScreenSize = glGetUniformLocation(shaders.damage.program, "love_ScreenSize");

   shaders.gamma_correction.program = gl_program_vert_frag("postprocess.vert", "gamma_correction.frag");
   shaders.gamma_correction.VertexPosition = glGetAttribLocation(shaders.gamma_correction.program, "VertexPosition");
   shaders.gamma_correction.ClipSpaceFromLocal = glGetUniformLocation(shaders.gamma_correction.program, "ClipSpaceFromLocal");
   shaders.gamma_correction.MainTex = glGetUniformLocation(shaders.gamma_correction.program, "MainTex");
   shaders.gamma_correction.gamma = glGetUniformLocation(shaders.gamma_correction.program, "gamma");

   shaders_loadSimple( "status", &shaders.status, "status.frag" );
   shaders_loadSimple( "factiondisk", &shaders.factiondisk, "factiondisk.frag" );
   shaders_loadSimple( "stealthaura", &shaders.stealthaura, "stealthaura.frag" );
   shaders_loadSimple( "spobmarker_empty", &shaders.spobmarker_empty, "spobmarker_empty.frag" );
   shaders_loadSimple( "spobmarker_earth", &shaders.spobmarker_earth, "spobmarker_earth.frag" );
   shaders_loadSimple( "spobmarker_rhombus", &shaders.spobmarker_rhombus, "spobmarker_rhombus.frag" );
   shaders_loadSimple( "spobmarker_triangle", &shaders.spobmarker_triangle, "spobmarker_triangle.frag" );
   shaders_loadSimple( "spobmarker_wormhole", &shaders.spobmarker_wormhole, "spobmarker_wormhole.frag" );
   shaders_loadSimple( "jumpmarker", &shaders.jumpmarker, "jumpmarker.frag" );
   shaders_loadSimple( "pilotmarker", &shaders.pilotmarker, "pilotmarker.frag" );
   shaders_loadSimple( "playermarker", &shaders.playermarker, "playermarker.frag" );
   shaders_loadSimple( "blinkmarker", &shaders.blinkmarker, "blinkmarker.frag" );
   shaders_loadSimple( "sysmarker", &shaders.sysmarker, "sysmarker.frag" );
   shaders_loadSimple( "notemarker", &shaders.notemarker, "notemarker.frag" );
   shaders_loadSimple( "asteroidmarker", &shaders.asteroidmarker, "asteroidmarker.frag" );
   shaders_loadSimple( "targetship", &shaders.targetship, "targetship.frag" );
   shaders_loadSimple( "targetspob", &shaders.targetspob, "targetspob.frag" );
   shaders_loadSimple( "jumplane", &shaders.jumplane, "jumplane.frag" );
   shaders_loadSimple( "jumplanegoto", &shaders.jumplanegoto, "jumplanegoto.frag" );
   shaders_loadSimple( "safelane", &shaders.safelane, "safelane.frag" );
   shaders_loadSimple( "iflockon", &shaders.iflockon, "iflockon.frag" );
   shaders_loadSimple( "gear", &shaders.gear, "gear.frag" );
   shaders_loadSimple( "selectspob", &shaders.selectspob, "selectspob.frag" );
   shaders_loadSimple( "selectposition", &shaders.selectposition, "selectposition.frag" );
   shaders_loadSimple( "sdfsolid", &shaders.sdfsolid, "sdfsolid.frag" );
   shaders_loadSimple( "circle", &shaders.circle, "circle.frag" );
   shaders_loadSimple( "crosshairs", &shaders.crosshairs, "crosshairs.frag" );
   shaders_loadSimple( "astaura", &shaders.astaura, "astaura.frag" );
   shaders_loadSimple( "hilight", &shaders.hilight, "hilight.frag" );
   shaders_loadSimple( "hilight_circle", &shaders.hilight_circle, "hilight_circle.frag" );
   shaders_loadSimple( "stealthmarker", &shaders.stealthmarker, "stealthmarker.frag" );
   shaders_loadSimple( "healthbar", &shaders.healthbar, "healthbar.frag" );
   qsort( shaders.simple_shaders, nsimpleshaders, sizeof(SimpleShader*), shaders_cmp );
}

void shaders_unload (void) {
   glDeleteProgram(shaders.solid.program);
   glDeleteProgram(shaders.trail.program);
   glDeleteProgram(shaders.smooth.program);
   glDeleteProgram(shaders.texture.program);
   glDeleteProgram(shaders.texture_interpolate.program);
   glDeleteProgram(shaders.stealthoverlay.program);
   glDeleteProgram(shaders.nebula.program);
   glDeleteProgram(shaders.nebula_background.program);
   glDeleteProgram(shaders.nebula_puff.program);
   glDeleteProgram(shaders.nebula_map.program);
   glDeleteProgram(shaders.points.program);
   glDeleteProgram(shaders.stars.program);
   glDeleteProgram(shaders.lines.program);
   glDeleteProgram(shaders.font.program);
   glDeleteProgram(shaders.beam.program);
   glDeleteProgram(shaders.jump.program);
   glDeleteProgram(shaders.material.program);
   glDeleteProgram(shaders.colorblind.program);
   glDeleteProgram(shaders.shake.program);
   glDeleteProgram(shaders.damage.program);
   glDeleteProgram(shaders.gamma_correction.program);
   glDeleteProgram(shaders.status.program);
   glDeleteProgram(shaders.factiondisk.program);
   glDeleteProgram(shaders.stealthaura.program);
   glDeleteProgram(shaders.spobmarker_empty.program);
   glDeleteProgram(shaders.spobmarker_earth.program);
   glDeleteProgram(shaders.spobmarker_rhombus.program);
   glDeleteProgram(shaders.spobmarker_triangle.program);
   glDeleteProgram(shaders.spobmarker_wormhole.program);
   glDeleteProgram(shaders.jumpmarker.program);
   glDeleteProgram(shaders.pilotmarker.program);
   glDeleteProgram(shaders.playermarker.program);
   glDeleteProgram(shaders.blinkmarker.program);
   glDeleteProgram(shaders.sysmarker.program);
   glDeleteProgram(shaders.notemarker.program);
   glDeleteProgram(shaders.asteroidmarker.program);
   glDeleteProgram(shaders.targetship.program);
   glDeleteProgram(shaders.targetspob.program);
   glDeleteProgram(shaders.jumplane.program);
   glDeleteProgram(shaders.jumplanegoto.program);
   glDeleteProgram(shaders.safelane.program);
   glDeleteProgram(shaders.iflockon.program);
   glDeleteProgram(shaders.gear.program);
   glDeleteProgram(shaders.selectspob.program);
   glDeleteProgram(shaders.selectposition.program);
   glDeleteProgram(shaders.sdfsolid.program);
   glDeleteProgram(shaders.circle.program);
   glDeleteProgram(shaders.crosshairs.program);
   glDeleteProgram(shaders.astaura.program);
   glDeleteProgram(shaders.hilight.program);
   glDeleteProgram(shaders.hilight_circle.program);
   glDeleteProgram(shaders.stealthmarker.program);
   glDeleteProgram(shaders.healthbar.program);
   memset(&shaders, 0, sizeof(shaders));
   nsimpleshaders = 0;
}