/* FILE GENERATED BY /builddir/build/BUILD/naev-nodata-0.10.2/redhat-linux-build/../src/shaders_c_gen.py */
#pragma once

#include "glad.h"

#define NUM_SIMPLE_SHADERS  32

typedef struct SimpleShader_ {
   const char *name;
   GLuint program;
   GLuint vertex;
   GLuint projection;
   GLuint color;
   GLuint dimensions;
   GLuint dt;
   GLuint parami;
   GLuint paramf;
   GLuint paramv;
} SimpleShader;

typedef struct Shaders_ {
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint color;
   } solid;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint c1;
      GLuint c2;
      GLuint t1;
      GLuint t2;
      GLuint dt;
      GLuint pos1;
      GLuint pos2;
      GLuint r;
      GLuint nebu_col;
      struct {
         GLuint uniform;
         GLuint trail_default;
         GLuint trail_pulse;
         GLuint trail_wave;
         GLuint trail_flame;
         GLuint trail_nebula;
         GLuint trail_arc;
         GLuint trail_bubbles;
      } trail_func;
   } trail;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint vertex_color;
      GLuint projection;
   } smooth;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint color;
      GLuint tex_mat;
      GLuint sampler;
   } texture;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint color;
      GLuint tex_mat;
      GLuint sampler1;
      GLuint sampler2;
      GLuint inter;
   } texture_interpolate;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint color;
      GLuint tex_mat;
   } stealthoverlay;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint hue;
      GLuint nonuniformity;
      GLuint horizon;
      GLuint eddy_scale;
      GLuint time;
   } nebula;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint hue;
      GLuint nonuniformity;
      GLuint eddy_scale;
      GLuint time;
      GLuint volatility;
   } nebula_background;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint nebu_col;
      GLuint time;
      GLuint r;
   } nebula_puff;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint hue;
      GLuint time;
      GLuint globalpos;
      GLuint alpha;
      GLuint volatility;
   } nebula_map;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint vertex_color;
      GLuint projection;
   } points;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint brightness;
      GLuint projection;
      GLuint star_xy;
      GLuint dims;
      GLuint xy;
      GLuint use_lines;
   } stars;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint colour;
   } lines;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint tex_coord;
      GLuint projection;
      GLuint m;
      GLuint color;
      GLuint outline_color;
   } font;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint color;
      GLuint dt;
      GLuint r;
      GLuint dimensions;
      struct {
         GLuint uniform;
         GLuint beam_default;
         GLuint beam_wave;
         GLuint beam_arc;
         GLuint beam_helix;
         GLuint beam_organic;
         GLuint beam_unstable;
         GLuint beam_fuzzy;
      } beam_func;
   } beam;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint projection;
      GLuint progress;
      GLuint direction;
      GLuint dimensions;
      GLuint brightness;
      struct {
         GLuint uniform;
         GLuint jump_default;
         GLuint jump_nebula;
         GLuint jump_organic;
         GLuint jump_circular;
         GLuint jump_wind;
      } jump_func;
   } jump;
   struct {
      GLuint program;
      GLuint vertex;
      GLuint vertex_normal;
      GLuint vertex_tex;
      GLuint projection;
      GLuint model;
      GLuint map_Kd;
      GLuint map_Ks;
      GLuint map_Ke;
      GLuint map_Bump;
      GLuint Ns;
      GLuint Ka;
      GLuint Kd;
      GLuint Ks;
      GLuint Ke;
      GLuint Ni;
      GLuint d;
      GLuint bm;
   } material;
   struct {
      GLuint program;
      GLuint VertexPosition;
      GLuint ClipSpaceFromLocal;
      GLuint MainTex;
   } colorblind;
   struct {
      GLuint program;
      GLuint VertexPosition;
      GLuint ClipSpaceFromLocal;
      GLuint MainTex;
      GLuint shake_pos;
      GLuint shake_vel;
      GLuint shake_force;
   } shake;
   struct {
      GLuint program;
      GLuint VertexPosition;
      GLuint ClipSpaceFromLocal;
      GLuint MainTex;
      GLuint damage_strength;
      GLuint love_ScreenSize;
   } damage;
   struct {
      GLuint program;
      GLuint VertexPosition;
      GLuint ClipSpaceFromLocal;
      GLuint MainTex;
      GLuint gamma;
   } gamma_correction;
   SimpleShader status;
   SimpleShader factiondisk;
   SimpleShader stealthaura;
   SimpleShader spobmarker_empty;
   SimpleShader spobmarker_earth;
   SimpleShader spobmarker_rhombus;
   SimpleShader spobmarker_triangle;
   SimpleShader spobmarker_wormhole;
   SimpleShader jumpmarker;
   SimpleShader pilotmarker;
   SimpleShader playermarker;
   SimpleShader blinkmarker;
   SimpleShader sysmarker;
   SimpleShader notemarker;
   SimpleShader asteroidmarker;
   SimpleShader targetship;
   SimpleShader targetspob;
   SimpleShader jumplane;
   SimpleShader jumplanegoto;
   SimpleShader safelane;
   SimpleShader iflockon;
   SimpleShader gear;
   SimpleShader selectspob;
   SimpleShader selectposition;
   SimpleShader sdfsolid;
   SimpleShader circle;
   SimpleShader crosshairs;
   SimpleShader astaura;
   SimpleShader hilight;
   SimpleShader hilight_circle;
   SimpleShader stealthmarker;
   SimpleShader healthbar;
   SimpleShader *simple_shaders[ NUM_SIMPLE_SHADERS ];
} Shaders;

extern Shaders shaders;

void shaders_load (void);
void shaders_unload (void);
const SimpleShader *shaders_getSimple( const char *name );
